Subject: Re: [bitcoindev] Pre-emptive commit/reveal for quantum-safe migration (poison-pill)

From: Leo Wandersleb <[email-masked]>
Date: Thu, 5 Jun 2025 01:18:26 -0700 (PDT)

Hi Boris, hi list,

I think the weak announcement is a bad idea once EC crypto is broken to the 
point where an attacker can break the key before the transaction gets mined 
but the strong announcements should still hold as they have less urgency. 
If the attacker sees the transaction in a strong announcement with a full 
transaction, he cannot win even if he gets into a block first, as the 
strong announcement proves a prior commitment to that transaction and would 
win even if it gets mined only some blocks later.

A scheme where the announcement does not contain the full transaction is 
problematic as the transaction might then turn out to not be valid. Then 
nodes would wait for the "winning" wtxid blocking the UTXO forever.

So the scheme is:

After activation at block height X:

1. **Vulnerable UTXOs cannot be spent directly** - they require a prior 
announcement 
2. **Commitment** to a wTXID that spends the vulnerable UTXO. Multiple 
wTXIDs can be stored in a hash tree in an OP_RETURN
3. **Reveal** full transaction with proof of prior commitment but not as a 
normal transaction yet
4. **Counter Reveal**: For 144 blocks, others can reveal older commitments. 
This protects exposed pubkeys!
5. **After 144 blocks**: The UTXO can be spent according to the strongest 
announcement (oldest commitment of valid transaction wins).

As (5) is just the normal transaction, the scheme is a soft fork and 
compatible with pre-recorded transactions where the keys were lost. It 
would at least double the on-chain costs for these vulnerable UTXOs as they 
would have to store the full transaction twice. We can make the 
announcements prunable again though.

Best,

Leo
On Wednesday, 4 June 2025 at 20:40:32 UTC+2 Boris Nagaev wrote:

> Hi Leo,
>
> I think it is possible to provide privacy for Satoshi and also reduce the 
> size of a weak announcement (strong announcements can already be small: 
> just a txid or a Merkle root of many txids).
>
> Importantly, we cannot include the whole signed transaction in the weak 
> announcement. Doing so would leak the EC public key immediately, allowing 
> an attacker to create their own valid weak announcement. We must avoid 
> revealing the public key until the actual spending transaction is broadcast.
>
> We need a scheme where the EC public key is not leaked in a weak 
> announcement, but the legitimate owner can verify it, while no one else 
> can. Also, once the EC public key is revealed, anyone should be able to 
> verify a past weak announcement (to validate the transaction when it is 
> broadcast). This reduces to the following requirement: we need a proof of 
> knowledge of the EC public key that can be verified if the public key is 
> known and provides no information otherwise.
>
> I think this is called a zero-knowledge proof. One simple approach could 
> be to apply a tagged hash function to the concatenation of the EC public 
> key and the future wTXID, and include this in the weak announcement. The 
> structure would be:
>
>    -     UTXO (previous TXID and output index)
>    -     future spending wTXID
>    -     proof := tagged_hash(EC public key || wTXID)
>
> The wTXID is included in the concatenation to bind the proof to a 
> particular future transaction. Otherwise, someone could copy a weak 
> announcement and substitute their own wTXID.
>
> Satoshi could publish a strong announcement now and then monitor all weak 
> announcements involving his UTXOs. If someone publishes a weak announcement 
> for one of his coins, he could verify the "proof" field. If it is valid, it 
> would mean someone has cracked his key with a quantum computer, and he 
> would need to use his strong announcement immediately to reclaim the funds 
> before the attacker does.
>
> Best,
> Boris
>
> On Wednesday, June 4, 2025 at 2:40:53 PM UTC-3 Leo Wandersleb wrote:
>
> Hi Boris,
>
> the announcements, weak and strong would have to not be transactions yet 
> to be compatible with legacy nodes and thus keep it a soft-fork. They could 
> be OP_RETURN data. Only after the 144 blocks, the upgraded full nodes would 
> allow the inclusion of the actual transaction. This would mean the 
> transaction would be both in full in the OP_RETURN strong announcement and 
> without the witness part later, so it would be a bit expensive this way but 
> maybe we can do better?
>
> A node that gets updated would have to re-index all the blockchain to find 
> announcements if we don't introduce a time frame for actually using the 
> announcements. We could also say that any announcement has to be used 
> within another 1000 blocks. Then the upgrading node would have to re-index 
> the last 1000 blocks.
>
> The legitimate owner of a UTXO might wait for an attack for privacy 
> reasons. My proposal would allow Satoshi himself to make all his UTXOs 
> quantum safe without any of us learning about him being active. He could 
> add one 64B OP_RETURN in 2027 and when QC becomes an issue, we would learn 
> about him having been active in 2027 in 2040 when actually somebody tried 
> to attack and not in 2027 when people started to panic because of imminent 
> quantum breakthroughs.
> Hmm ... a problem is the weak announcement doesn't require keys, so 
> anybody could provoke Satoshi to come forward. Maybe we have to add key 
> ownership as a requirement for the "weak" announcement, too. So it should 
> also contain a serialized transaction.
>
> Best,
>
> Leo
>
> On Wednesday, 4 June 2025 at 04:15:59 UTC+2 Nagaev Boris wrote:
>
> Hi Leo, 
>
> Thanks for the clarifications, much appreciated! 
> I have a couple of questions: 
>
> 1. How is a weak announcement stored in the blockchain and in the UTXO 
> set? 
> I assume it must be a transaction, correct? And it should somehow mark 
> the UTXO as planned to be spent for 144 blocks? 
> How would older (non-upgraded) nodes interpret a transaction 
> containing a weak announcement? Would they just skip over it without 
> any special processing? 
> If so, is there a problem for nodes that upgrade after the fork: would 
> they have to reprocess all blocks since the fork to find and index all 
> missed weak announcements? 
>
> 2. In the case of reclaiming a UTXO after a weak announcement by an 
> attacker: why would the legitimate owner wait for a weak announcement 
> at all? 
> If the EC public key was already leaked, it seems they should publish 
> a strong announcement themselves rather than wait. If the EC public 
> key wasn't leaked, there's nothing to worry about even if someone 
> publishes a weak announcement: they are most likely bluffing, since 
> they wouldn't have the actual public key. 
>
> Best, 
> Boris 
>
> On Tue, Jun 3, 2025 at 3:29 PM Leo Wandersleb <[email-masked]> wrote: 
> > 
> > Hi conduition, 
> > 
> > Thanks for your careful analysis - excellent catches. 
> > 
> > You're absolutely right about the txid vulnerability. The commitment 
> must be to the complete transaction including witness data (wTXID or 
> equivalent) to prevent an attacker from pre-committing to unsigned 
> transactions. This is essential - otherwise an attacker could indeed 
> enumerate the UTXO set and create commitments without knowing the private 
> keys. 
> > 
> > Regarding updates: You're correct that frequent updates would be needed 
> as wallets receive new UTXOs. However, I don't see this as a major issue - 
> users could batch their commitments periodically (say, monthly) rather than 
> after every transaction. The scheme is particularly important for existing 
> UTXOs that already have exposed pubkeys (old P2PK, reused addresses, etc.). 
> For new UTXOs, wallets should ideally migrate to quantum-safe addresses 
> once available. OpenTimestamps aggregation would indeed help with scaling 
> and provide plausible deniability about the number of UTXOs being 
> protected. 
> > 
> > The time delay serves a different purpose than you might expect. It's 
> not about preventing commitment forgery after pubkey exposure, but rather 
> about allowing priority based on commitment age when multiple parties claim 
> the same UTXO: 
> > 
> > 1. Weak announcement starts the 144-block window 
> > 2. During this window, anyone with a strong commitment can reveal it 
> > 3. The oldest valid commitment wins 
> > 
> > This creates the "poison pill" effect: an attacker might crack a key and 
> try to spend a UTXO, but if the original owner has an older commitment, 
> they can reclaim it during the window. The uncertainty about which UTXOs 
> have poison pills makes attacking large "lost" UTXOs risky - hence less 
> disruptive to the network. 
> > 
> > The delay essentially allows a "commitment priority contest" where age 
> determines the winner, protecting users who prepared early while still 
> allowing these users to not move their funds. 
> > 
> > Best, 
> > 
> > Leo 
> > 
> > -- 
> > You received this message because you are subscribed to the Google 
> Groups "Bitcoin Development Mailing List" group. 
> > To unsubscribe from this group and stop receiving emails from it, send 
> an email to [email-masked]. 
> > To view this discussion visit 
> https://groups.google.com/d/msgid/bitcoindev/5e393f57-ac87-40fd-93ef-e1006accdb55n%40googlegroups.com. 
>
>
>
>
> -- 
> Best regards, 
> Boris Nagaev 
>
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/ea71bbd5-1325-445b-977f-a52b8017eab4n%40googlegroups.com.